# 🔒🛡️ Bunkoer

⚡  Building secure LLM applications through composability ⚡

## Quick Install

With pip: 

```
pip install bunkoer
```

## ⚙️ What is Bunkoer?

Bunkoer is a framework designed to secure the development of applications powered by language models. It facilitates solutions that:

- Ensure Privacy: Bunkoer links AI models with mechanisms to safeguard sensitive information (through anonymization techniques, privacy-preserving prompts, etc.)
- Foster Ethical AI: leans on AI models to uphold ethical standards (by evaluating and modifying responses to maintain privacy, determining appropriate data handling actions, etc.)

![Schema](images/schema.png)

## What can you build with Bunkoer?

💬 **Analyzing structured data**

Documentation
- End-to-end Example: CSV OpenAI Template

🤖 **Chatbots**

Documentation
- End-to-end Example: ChatGPT 4 

## How Does Bunkoer Help? 

The core strengths of the Bunkoer framework are:

- **Modular Features**: Tailored tools and integrations for enhancing data privacy in AI models. These features are designed to be both modular and user-friendly, applicable within and beyond the Bunkoer framework.
- **Pre-configured Anonymization Processes**: Ready-made combinations of features aimed at achieving higher-level privacy tasks.

## License 

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Bunkoer Software"), to deal in the Bunkoer Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Bunkoer Software, and to permit persons to whom the Bunkoer Software is furnished to do so, subject to the following conditions:

Commercial Clause: Notwithstanding the above, the use of the Bunkoer Software for commercial purposes is conditioned upon the conclusion of a separate commercial license agreement. "Commercial use" refers to the use of the Bunkoer Software in a product or service that is sold, rented, or used for the purpose of generating revenue. To negotiate a commercial license agreement, please contact us at bunkoer@bunkoer.com.

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Bunkoer Software.

THE BUNKOER SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE BUNKOER SOFTWARE OR THE USE OR OTHER DEALINGS IN THE BUNKOER SOFTWARE.
